Bug 952632 (qtermwidget) - Review Request: qtermwidget - Qt4 terminal widget
Summary: Review Request: qtermwidget - Qt4 terminal widget
Keywords:
Status: CLOSED ERRATA
Alias: qtermwidget
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Brendan Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: Trivial
Depends On:
Blocks: qt-reviews
TreeView+ depends on / blocked
 
Reported: 2013-04-16 10:47 UTC by Eugene A. Pivnev
Modified: 2014-12-27 19:52 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-12-27 19:52:08 UTC
brendan.jones.it: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Eugene A. Pivnev 2013-04-16 10:47:14 UTC
Spec URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget.spec
SRPM URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget-0.4.0-1.src.rpm
Description: Qt4 terminal widget
Fedora Account System Username: tieugene

Koji:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5257590
http://koji.fedoraproject.org/koji/taskinfo?taskID=5257593
http://koji.fedoraproject.org/koji/taskinfo?taskID=5257604
http://koji.fedoraproject.org/koji/taskinfo?taskID=5257614

Rpmlint:
rpmlint rpmbuild/SPECS/qtermwidget.spec rpmbuild/SRPMS/qtermwidget-0.4.0-1.src.rpm rpmbuild/RPMS/i686/qtermwidget-0.4.0-1.i686.rpm rpmbuild/RPMS/i686/qtermwidget-devel-0.4.0-1.i686.rpm
qtermwidget.src: W: spelling-error %description -l en_US embeddable -> embedded
qtermwidget.i686: W: spelling-error %description -l en_US embeddable -> embedded
qtermwidget-devel.i686: W: no-documentation
3 packages and 1 specfiles checked; 0 errors, 3 warnings.

Note: this library will need for future qterminal package.

Comment 1 Micah Roth 2013-04-17 19:54:52 UTC
Dear tieugene,

This is my very first review, so this is unofficial. But I was very carefully walked through the process by an some experienced people (thanks volter and nirik!), so I think you will find it useful. 


Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines. 
[?]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     qtermwidget-devel 
## See: http://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_base_package; you are missing the %{?_isa} macro and the %{release} macro in your string.

[x]: Package complies to the Packaging Guidelines
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v2 or later)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown
     or generated". 4 files have unknown license. Detailed output of
     licensecheck in /home/makerpm/952632-qtermwidget/licensecheck.txt
## This probably qualifies as a Multiple Licencing Scenario: http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Multiple_Licensing_Scenarios you should add the other licenses to your License: string, with "and"s between them.

[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 4 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: Dist tag is present.
## Add the %{?dist} macro to your Release string.

[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
## %{_libdir}/qt4/plugins/designer/lib%{name}plugin.so should be under %files, not '%files devel' 

[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: qtermwidget-0.4.0-1.i686.rpm
          qtermwidget-devel-0.4.0-1.i686.rpm
qtermwidget.i686: W: spelling-error %description -l en_US embeddable -> embedded
qtermwidget-devel.i686: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint qtermwidget qtermwidget-devel
qtermwidget.i686: W: spelling-error %description -l en_US embeddable -> embedded
qtermwidget.i686: W: unused-direct-shlib-dependency /usr/lib/libqtermwidget.so.0.4.0 /lib/libm.so.6
qtermwidget-devel.i686: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
qtermwidget (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libQtCore.so.4
    libQtGui.so.4
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    rtld(GNU_HASH)

qtermwidget-devel (rpmlib, GLIBC filtered):
    libQtCore.so.4
    libQtDesigner.so.4
    libQtDesignerComponents.so.4
    libQtGui.so.4
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libqtermwidget.so.0
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    qtermwidget
    rtld(GNU_HASH)



Provides
--------
qtermwidget:
    libqtermwidget.so.0
    qtermwidget
    qtermwidget(x86-32)

qtermwidget-devel:
    libqtermwidgetplugin.so
    qtermwidget-devel
    qtermwidget-devel(x86-32)



MD5-sum check
-------------
https://github.com/qterminal/qtermwidget/archive/0.4.0.tar.gz :
  CHECKSUM(SHA256) this package     : cb279e8389133ceca00feece59568d9e2c4dab273ff7d295c225cf0f713c68e9
  CHECKSUM(SHA256) upstream package : cb279e8389133ceca00feece59568d9e2c4dab273ff7d295c225cf0f713c68e9


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-18-i386
Command line :/usr/bin/fedora-review -b 952632


## "Environment" may not be the best term for your -devel package %description, won't just "development files for..." work? Might confuse some users searching for "desktop environment" or something like that.

## Should include some indicator of what your patch file does and what action with upstream you have taken, see: http://fedoraproject.org/wiki/Packaging:Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

Comment 2 Eugene A. Pivnev 2013-04-18 07:16:03 UTC
(In reply to comment #1)
> [?]: %build honors applicable compiler flags or justifies otherwise.

I use %cmake and _smp_mflags macros. I think - this is enough.

> [!]: Fully versioned dependency in subpackages, if present.

Fixed.

> [!]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses found:
>      "LGPL (v2 or later)", "GPL (v2 or later)", "GPL (v3 or later)", "Unknown
>      or generated". 4 files have unknown license. Detailed output of
>      licensecheck in /home/makerpm/952632-qtermwidget/licensecheck.txt
> ## This probably qualifies as a Multiple Licencing Scenario:
> http://fedoraproject.org/wiki/Packaging:
> LicensingGuidelines#Multiple_Licensing_Scenarios you should add the other
> licenses to your License: string, with "and"s between them.

GPLv3 is in unused code (pyqt4 example).
As for LGPL vs GPL - according to compatibility matrix (https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#GPL_Compatibility_Matrix) I can use LGPLv2.1+ code if publish package under GPLv2+.
It is.

> [!]: Dist tag is present.

Fixed.

> [!]: Final provides and requires are sane (see attachments).
> ## %{_libdir}/qt4/plugins/designer/lib%{name}plugin.so should be under
> %files, not '%files devel' 

Fixed.

> [?]: Package functions as described.

This package will used in qterminal package. Now you can test it using OBS packages: http://download.opensuse.org/repositories/X11:/QtDesktop/

> [!]: Patches link to upstream bugs/comments/lists or are otherwise justified.

Fixed.

> [?]: Package should compile and build into binary rpms on all supported
>      architectures.

See Koji links in 1st comments.

> [!]: %check is present and all tests pass.

"make check" not supported - so %check section is not need: http://fedoraproject.org/wiki/How_to_create_an_RPM_package#.25check_section

> ## "Environment" may not be the best term for your -devel package

Fixed.

> ## Should include some indicator of what your patch file does and what
> action with upstream you have taken, see:

Fixed.

Thank you for a good job.

New URLs:

Spec URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget.spec
SRPM URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget-0.4.0-2.fc18.src.rpm

Comment 3 Volker Fröhlich 2013-04-18 07:55:55 UTC
> [?]: %build honors applicable compiler flags or justifies otherwise.

There's a -O3 past our -O2. I think that grabs.

Comment 4 Eugene A. Pivnev 2013-04-18 08:03:25 UTC
(In reply to comment #3)
> > [?]: %build honors applicable compiler flags or justifies otherwise.
> 
> There's a -O3 past our -O2. I think that grabs.

I agree.
Qtermwidget not set -O flag at all.
Seems this is cmake package bug: https://bugzilla.redhat.com/show_bug.cgi?id=875954

Comment 5 Orion Poplawski 2013-04-18 15:26:11 UTC
Can you try adding -DCMAKE_CXX_FLAGS_RELEASE_INIT=-DNDEBUG to see if that removes the -O3?

Comment 6 Orion Poplawski 2013-04-18 15:28:37 UTC
Actually, in this case, just remove CMAKE_BUILD_TYPE=Release

Comment 7 Eugene A. Pivnev 2013-04-18 15:50:39 UTC
(In reply to comment #6)
> Actually, in this case, just remove CMAKE_BUILD_TYPE=Release

Yes, simple "%cmake .." builds with -O2 only.
Thank you.

Comment 8 Micah Roth 2013-04-18 16:08:27 UTC
> > [?]: Package functions as described.
> 
> This package will used in qterminal package. Now you can test it using OBS
> packages: http://download.opensuse.org/repositories/X11:/QtDesktop/
> 

qterminal confirmed working with this build on F18.i386

Comment 9 Micah Roth 2013-04-18 18:52:45 UTC
(In reply to comment #7)
> (In reply to comment #6)
> > Actually, in this case, just remove CMAKE_BUILD_TYPE=Release
> 
> Yes, simple "%cmake .." builds with -O2 only.
> Thank you.

Please post new spec and srpm with this change.

Comment 10 Eugene A. Pivnev 2013-04-18 19:20:06 UTC
> Please post new spec and srpm with this change.

No problem.

Spec URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget.spec
SRPM URL: http://tieugene.fedorapeople.org/rpms/qtermwidget/qtermwidget-0.4.0-3.fc18.src.rpm

Thank you for final (?) resolving of "-O3" problem.

Comment 11 Brendan Jones 2013-04-22 19:58:15 UTC
This is good to go once you address this:

[!]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     qtermwidget-devel 
## See: http://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_base_package; you are missing the %{?_isa} macro and the %{release} macro in your string.

I won't repeat the fedora-review, but here's my synopsis

 - package meets naming guidelines, spec file is legible with consistent use of macros
 - license is permissable and is available to all packages and sub-packages
 - package(s) own all the files / directories it 
 - rpmlint OK
 - built in mock OK
 - sane requires
 - package functions as expected

This package is APPROVED

Comment 12 Eugene A. Pivnev 2013-04-23 09:31:56 UTC
(In reply to comment #11)
> you are missing the %{?_isa} macro and the %{release} macro in your string.

Sorry - _isa AND release? Or _isa only?

Comment 13 Micah Roth 2013-04-23 15:15:35 UTC
(In reply to comment #12)
> (In reply to comment #11)
> > you are missing the %{?_isa} macro and the %{release} macro in your string.
> 
> Sorry - _isa AND release? Or _isa only?

http://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package

<quote>
Devel packages are an example of a package that must require their base packages using a fully versioned dependency.

...

When a subpackage requires the base package, it must do so using a fully versioned arch-specific (for non-noarch packages) dependency:

Requires: %{name}%{?_isa} = %{version}-%{release}
</quote>

Comment 14 Eugene A. Pivnev 2013-04-23 15:23:26 UTC
(In reply to comment #13)

No, no...
You wrote "you are missing the %{?_isa} macro and the %{release} macro in your string".
I look in spec - I set "= %{name} = %{version}-%{release}".
Or we look in different specs?

It is important for me - to know where I forgot %{release}. Else...

Comment 15 Volker Fröhlich 2013-04-23 15:36:06 UTC
Just make it like in the quoted caption from the guidelines.

Comment 17 Eugene A. Pivnev 2013-04-23 16:01:57 UTC
New Package SCM Request
=======================
Package Name: qtermwidget
Short Description: Qt4 terminal widget
Owners: tieugene
Branches: f17 f18 f19 el6
InitialCC:

Comment 18 Gwyn Ciesla 2013-04-23 16:08:39 UTC
Git done (by process-git-requests).

Comment 19 Fedora Update System 2013-04-23 22:54:39 UTC
qtermwidget-0.4.0-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/qtermwidget-0.4.0-4.fc19

Comment 20 Fedora Update System 2013-04-23 22:56:23 UTC
qtermwidget-0.4.0-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/qtermwidget-0.4.0-4.fc18

Comment 21 Fedora Update System 2013-04-23 22:58:08 UTC
qtermwidget-0.4.0-4.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/qtermwidget-0.4.0-4.fc17

Comment 22 Fedora Update System 2013-04-24 16:31:32 UTC
qtermwidget-0.4.0-4.fc19 has been pushed to the Fedora 19 testing repository.

Comment 23 Fedora Update System 2013-05-05 02:27:24 UTC
qtermwidget-0.4.0-4.fc18 has been pushed to the Fedora 18 stable repository.

Comment 24 Fedora Update System 2013-05-05 02:27:56 UTC
qtermwidget-0.4.0-4.fc17 has been pushed to the Fedora 17 stable repository.

Comment 25 Fedora Update System 2013-05-05 03:24:46 UTC
qtermwidget-0.4.0-4.fc19 has been pushed to the Fedora 19 stable repository.

Comment 26 Eugene A. Pivnev 2014-09-26 10:36:06 UTC
New Package SCM Request
=======================
Package Name: qtermwidget
Short Description: Qt4 terminal widget
Owners: tieugene
Branches: epel7

Comment 27 Gwyn Ciesla 2014-09-26 12:08:30 UTC
Git done (by process-git-requests).

Comment 28 Rex Dieter 2014-12-27 19:52:08 UTC
re-closing, no need to have re-opened just for fedora-cvs


Note You need to log in before you can comment on or make changes to this bug.